<?php
// No direct access to this file
defined('_JEXEC') or die('Restricted access');
 
// import Joomla controller library
jimport('joomla.application.component.controller');
 
/**
 * General Controller of current component
 */
class DemoLoaderControllerLoader extends JControllerLegacy
{
	...

	/**
	 * initialise les données et l'avancement pour une entrée produit
	 */
	public function initAjaxProduits() {
		$input = JFactory::getApplication()->input;
		$id = $input->get('id', 0);
		$autreChamp = $input->get('autre_champ', "");

		$percentProduits = 0;
		$msgErr = "";

		if(!$id && empty($autreChamp)) {
			$percentProduits = -1;
			$msgErr = "<b>Erreur :</b> ID et/ou autreChamp incorrect";
		} else {
			if($id && $autreChamp) {
				foreach(...) {
					$produitAddOn = new stdClass();
						$produitAddOn->produit_id	=	$id;
						...
						$produitAddOn->created	=	$date->toSql();
						$produitAddOn->created_by	=	$user->get('id');
						$result = JFactory::getDbo()->insertObject('#__table_produits_liées', $produitAddOn);
						$cpt++;
					}
				}
				$percentProduits = floor(($cpt/... nbr enreges ...) * 100);
			} else {
				// fin de l'init
				$percentProduits = 0;
				$msgErr = "";
			}
		}

		// retour des infos AJAX
		$tJsonRet = array();
		$tJsonRet['pct_produits_loaded'] = $percentProduits; //=avancement en pourcentage pour la Progressbar
		$tJsonRet['err'] = $msgErr; //=msg d'erreur si plantage
		$jsonRet = json_encode($tJsonRet);
		echo $jsonRet;
	}
}


