<?php
defined('_JEXEC') or die('Restricted access');

/**
 * script TMPL en plusieurs parties :
 * - isLoader == true  (ligne 12), alors ajout code JS, on lance la modal et le traitement d'AJAX de preparation des données
 * 				avec l'appel de la modal
 * 					 la function d'appel/traitement AJAX
 * 					 la function Trigger... pour les itérations de progression
 * - puis selon isLoader (ligne 76), on affiche un form simplifié ou complet avec la modal
 */
if($this->isLoader) : ?>
	<script>
		jQuery(document).ready(function() {

			var produits = array()
			// + remplissage du tableau JS
			// ...

			console.log("modal show ...");
			jQuery('#modal-loader').modal('show');
			// lance l'initialisation en AJAX pour la 1ere tempo
			initProduit(produits[0]);
		});

		// fonction d'enregistrement et de chargement de l'avancement de l'initialisation des données
		function initProduit(produits) {
			jQuery.ajax({
				type: "POST",
				data: {id:<?php echo $this->item->id ?>, autre_champ:varJS}, dataType: "json",
				// appel de la fonction initAjaxProduits() du /controllers/loader.php
				url:  "<?php echo JUri::base(true) ?>/index.php?option=com_demoloader&task=loader.initAjaxProduits&tmpl=component&format=raw",
				success:function(data){
					console.log("Ajax success return data : "+JSON.stringify(data));
					try {
						retAjax = data;
						if(retAjax.err!="") {
							// erreur lors de l'init
							jQuery('#msgerr').html(retAjax.err);
							jQuery('#msgerr').css("display", "block");
						}
						else
						{
							valueNow = 50; // calcul de valeurs retourné par l'avancement
							// animation de la barre de progress
							jQuery('#progress-init').css('width', retAjax.pct_produits_loaded+'%');
							if(... pas la fin ...) {
								console.log("Trigger next date !");
								setTimeout(triggerNextInit, 800);
							} else {
								//si dernier appel Ajax, redirect ecran en edition (apres avoir init toutes les données)
								jQuery('#progress-init').css('width', '100%');
								document.location.href="<?php echo JUri::base(true) ?>/index.php?option=com_demoloader&view=produit&layout=edit&id=<?php echo $this->item->id ?>";
							}
						}
					} catch (e) {
						console.error("Parsing error:", e); 
					}
				},
				error:function(msg){
					jQuery(".modal-body0").html('<div style="color:red">Erreur ... ???</div>');
				}
			});
		} // fin initProduit()

		function triggerNextInit(){
			console.log('Bind event');
			initProduit(produits[... num du tab selon avancement ...]);
		}
	</script>
<?php endif; ?>

	<form action="<?php echo JRoute::_('index.php?option=com_demoloader&layout=edit&id='.(int) $this->item->id); ?>"
		  method="post" name="adminForm" id="produit-form" class="form-validate">

<?php if($this->isLoader==false) : ?>

		<?php //formulaire simplifé, à la création de l'enreg afin de ne saisir que les champs importants pour le Loader ?>
		<?php echo JLayoutHelper::render('joomla.edit.title_alias', $this); ?>
		<div class="span6 alert">
		  <button type="button" class="close" data-dismiss="alert">&times;</button>
		  <span class="icon-info"></span> <strong>Information :</strong> <br />
		  Veuillez saisir un <b>titre</b>,<br />
		  puis cliquez sur <b>[Enregistrer]</b> pour initialiser les données produits.
		</div>

<?php else : ?>

		<div id="container">
			... formulaire avec les champs de saisie complet qui s'afichent après l'init AJAX  ...
		</div>
		
		<!-- modal init Produits -->
		<div id="modal-loader" class="modal hide fade" style="max-width:600px">
			<div class="modal-dialog" style="max-width:600px">
				<div class="modal-content" style="max-width:600px">
					<div class="modal-header">
						<button type="button" role="presentation" class="close" data-dismiss="modal">&times;</button>
						<h3>Initialisation des produits</h3>
					</div>

					<div class="modal-body0">
						<div>Veuillez patienter pendant l'initialisation des produits ...</div>
						<div class="progress progress-striped active">
							<div id="progress-init" class="bar" style="width: 0%;"></div>
						</div>
						<div id="msgerr" class="well alert alert-error" style="display:none"></div>
					</div>

					<div class="modal-footer">
					</div>
				</div>
				<!-- /.modal-content -->
			</div>
			<!-- /.modal-dialog -->
		</div>

	</form>

<?php endif; ?>
